#!/usr/bin/env python
import sys
import Ice, IceStorm
import Combine
from threading import Thread

#-----------------------------------------------------------------------
class CommandI(Combine.Command):
    def cmd(self, inc, current=None):
        print inc
        
#-----------------------------------------------------------------------
class Subscriber(Thread):
    
    #---------------------------------------------------------------------------
    def __init__(self, args):
        Thread.__init__(self)
        self.args = args
        
    #---------------------------------------------------------------------------    
    def run(self):
        batch = False
        option = "None"
        topicName = "hw_events"
        id = ""
        retryCount = ""

        # Get a communicator
        communicator = Ice.initialize(self.args)

        manager = IceStorm.TopicManagerPrx.checkedCast(communicator.propertyToProxy('TopicManager.Proxy'))
        if not manager:
            print 'Invalid proxy'
            return 1

        #
        # Retrieve the topic.
        #
        try:
            topic = manager.retrieve(topicName)
        except IceStorm.NoSuchTopic, e:
            try:
                topic = manager.create(topicName)
            except IceStorm.TopicExists, ex:
                print self.appName() + ": temporary error. try again"
                return 1

        adapter = communicator.createObjectAdapter("Command.Subscriber")

	#
	# Add a servant for the Ice object. If --id is used the identity
	# comes from the command line, otherwise a UUID is used.
	#
	# id is not directly altered since it is used below to detect
	# whether subscribeAndGetPublisher can raise AlreadySubscribed.
	#

        subId = Ice.Identity()
        subId.name = id
        if len(subId.name) == 0:
            subId.name = Ice.generateUUID()
        subscriber = adapter.add(CommandI(), subId)
        
        #
        # Set up the proxy.
        #
        qos = {}
        try:
            topic.subscribeAndGetPublisher(qos, subscriber)
        except IceStorm.AlreadySubscribed, ex:
            # If we're manually setting the subscriber id ignore.
            if len(id) == 0:
                raise
            print "reactivating persistent subscriber"
            
        adapter.activate()

        communicator.shutdownOnInterrupt()
        communicator.waitForShutdown()

        #
        # Unsubscribe all subscribed objects.
        #
        topic.unsubscribe(subscriber)         
        print 'Subscriber thread exiting'
                
        return 0

#------------------------------------------------------------------------------- 
class AppMain():
    
    #---------------------------------------------------------------------------    
    def run(self, argv):
        sub = Subscriber(argv)
        sub.start()        
        print 'Subscriber thread running'
        
#--------------------------------------------------------------------------
#
# Start from the command line
#
if __name__ == "__main__":

    print 'Starting server side subscriber'
    main = AppMain()
    main.run(sys.argv)
    raw_input('Press any key to exit..')
  
    # Announce we are going 
    print 'Server side subscriber exiting'